//
//  ViewController.swift
//  SimpleTVOSSample
//
//  Created by David Cortes on 3/14/19.
//  Copyright © 2023 Akamai. All rights reserved.
//

import UIKit
import AVKit
import AmpCore
import AmpIMA
import GoogleInteractiveMediaAds

class ViewController: UIViewController {

    var ampPlayer: AmpPlayer!
    var ima:AmpIMAManager!
    var playerController: AVPlayerViewController = AVPlayerViewController()
    
    let liveURL = "http://csm-e.cds1.yospace.com/csm/extlive/yospace02,sampledroid.m3u8?yo.br=false&yo.ac=true"
    let vodURL = "https://mdtp-a.akamaihd.net/vod/hls/BLENDER-ELEPHANT-DREAM/master.m3u8"
    let shortURL = "http://cdnbakmi.kaltura.com/p/243342/sp/24334200/playManifest/entryId/0_uka1msg4/flavorIds/1_vqhfu6uy,1_80sohj7p/format/applehttp/protocol/http/a.m3u8"
    let adsUrl = "https://pubads.g.doubleclick.net/gampad/ads?iu=/21775744923/external/vmap_ad_samples&sz=640x480&cust_params=sample_ar%3Dpremidpost&ciu_szs=300x250&gdfp_req=1&ad_rule=1&output=vmap&unviewed_position_start=1&env=vp&impl=s&cmsid=496&vid=short_onecue&correlator="
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        self.ampPlayer = AmpPlayer(parentViewController: self, playerController: playerController)
        if #available(tvOS 14.0, *) {
            self.ima = AmpIMAManager(player: ampPlayer, videoView: self.view)
        } else {
            // Fallback on earlier versions
        }
        // self.ima.imaBitrate = 1024
        // self.ima.imaMimeTypes = ["video/mp4","application/x-mpegURL"]
        self.ima.registerImaObserver(self)
        self.ampPlayer.registerObserver(self)
        self.ampPlayer.autoplay = true
        self.ampPlayer.setLicense("AwFv5+fgXo/D//vn/bIMI8HyIAUB+8PH95TpJ0g64DJV0uzgcTxuVCwRCPDpL3/EzpHPrt8aqUw5+2kFs30tI3+kvkKf23f1TqyrNuQripifqTjdZAYWkUsQzKgwfDikvZwm9fuvOUFvXdrpGXnCz80FxUzeuQuSlfyglyL12domAPhcP1TTDckRHpRndludeicEfQvLp4IGQJxqkUSeRYoNflLMsmEI+XF3hGAKpGml3A==")

        self.ampPlayer.play(url: vodURL)
    }
    
    override func viewDidAppear(_ animated: Bool) {
        // ima.requestLiveStream(assetkey: "sN_IYUG8STe1ZzhIIE_ksA", fallbackUrl: vodURL)
        ima.requestImaAds(adTagUrl: adsUrl)
    }
    
}

extension ViewController:PlayerEventObserver, IMAAdsManagerDelegate {
    func adsManager(_ adsManager: IMAAdsManager, didReceive event: IMAAdEvent) {
        
    }
    
    func adsManager(_ adsManager: IMAAdsManager, didReceive error: IMAAdError) {
        
    }
    
    func adsManagerDidRequestContentPause(_ adsManager: IMAAdsManager) {
        
    }
    
    func adsManagerDidRequestContentResume(_ adsManager: IMAAdsManager) {
        
    }
    
    func onAmpError(_ ampPlayer: AmpPlayer, error: PlayerError, code: Int, message: String) {
        print("An error has occurred \(error) \(code) \(message)")
    }
}

